package cn.estsh.i3plus.pojo.base.annotation;

import cn.estsh.i3plus.pojo.base.enumutil.WmsEnumUtil;

import java.lang.annotation.*;

/**
 * 字段类型属性注解
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.FIELD})
public @interface FieldAnnotation {
    // Web前端字段数据类型
    WmsEnumUtil.FIELD_TYPE webFieldType();
    // 条件表达式:>,<,>=等
    String conditionExpre() default "=";
    // 条件连接符:and/or
    String conditionConnector() default "and";
    // 排序序号
    int seq() default 0;
    // 字段列宽度
    double width() default 0d;
    // 排序规则:默认0-不排序，1-升序2-降序
    int sort() default 0;
    // 是否标题字段加粗 是否加粗:默认1-加粗，2-非加粗
    int isWider() default 2;
    // 是否勾选:默认1-勾选，2-非勾选
    int isSelect() default 1;
    // 是否必选:默认1-必选，2-非必选
    int isRequire() default 1;
    // 是否表单字段展示:默认1-显示，2-隐藏
    int isShow() default 1;
}
