package cn.estsh.i3plus.pojo.mes.pcn.bean;


import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :JIS发运模式
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2019-12-25
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_PATTERN_JIS")
@Api("JIS发运模式")
public class MesPatternJis extends BaseBean {

    @Column(name = "PATTERN_NO")
    @ApiParam("模式编号")
    private String patternNo;

    @Column(name = "PATTERN_NAME")
    @ApiParam("模式名称")
    private String patternName;

    @Column(name = "RULE")
    @ApiParam("规则")
    private String rule;

    @Column(name = "PATTERN_DESC")
    @ApiParam("描述")
    private String patternDesc;

    @Column(name = "TOP_NO")
    @ApiParam("一次显示TOP数")
    private Integer topNo;

    @Column(name = "HANDLE_NO")
    @ApiParam("一次处理套数")
    private Integer handleNo;

    @Column(name = "PATTERN_TYPE")
    @ApiParam("模式类型")
    private Integer patternType;

    @Column(name = "SCAN_TYPE")
    @ApiParam("是否按主队列顺序扫描")
    private Integer scanType;

}
