package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.util.List;

/**
 * @Description : 自定义报表布局
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-25 19:54
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_LAYOUT")
@Api(value="自定义报表布局",description = "单独进行管理，生成报表是使用。报表实例 * -》 1")
public class BrLayout extends BaseBean {

    @Column(name="LAYOUT_NAME")
    @ApiParam(value ="名称")
    private String layoutName;

    @Column(name="LAYOUT_WIDTH")
    @ApiParam(value ="布局宽度")
    private Double layoutWidth;

    @Column(name="LAYOUT_HEIGHT")
    @ApiParam(value ="布局高度")
    private Double layoutHeight;

    @Column(name="LAYOUT_ROW_COUNT")
    @ApiParam(value ="行数")
    private Integer layoutRowCount;

    @Column(name="LAYOUT_COLUMN_COUNT")
    @ApiParam(value ="列数")
    private Integer layoutColumnCount;

    @Column(name="LAYOUT_REPORT_COUNT")
    @ApiParam(value ="引用报表数量")
    private Integer layoutReportCount;

//    @Lob
//    @Column(name="LAYOUT_HTML")
//    @ApiParam(value ="布局html")
//    private String layoutHtml;
//
//    @Lob
    @Column(name = "LAYOUT_DESCRIPTION")
    @ApiParam(value ="布局描述")
    private String layoutDescription;

    @Transient
    @ApiParam(value ="模板行列表")
    private List<BrLayoutRow> brLayoutRows;
}
