package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.util.List;

/**
 * @Description : 自定义报表布局
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-25 19:54
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_LAYOUT_COLUMN")
@Api(value="自定义报表布局-列",description = "一行包含多列")
public class BrLayoutColumn extends BaseBean {

    @Column(name="LAYOUT_ID")
    @ApiParam(value ="布局主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long layoutId;

    @Column(name="LAYOUT_ROW_ID")
    @ApiParam(value ="行主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long layoutRowId;

    @Column(name="COLUMN_COLSPAN")
    @ApiParam(value ="跨列数")
    private Integer columnColspan;

    @Column(name="COLUMN_ROWSPAN")
    @ApiParam(value ="跨行数")
    private Integer columnRowspan;

    @Column(name="COLUMN_WIDTH")
    @ApiParam(value ="列宽")
    private Integer columnWidth;

    @Column(name="COLUMN_HEIGHT")
    @ApiParam(value ="列高")
    private Integer columnHeight;

    @Column(name="COLUMN_STYLE")
    @ApiParam(value ="列样式")
    private String columnStyle;

    @Column(name="COLUMN_SEQ")
    @ApiParam(value ="序列")
    private Integer columnSeq;

    @Column(name="COLUMN_SORT")
    @ApiParam(value ="排序，降序")
    private Integer columnSort;

//    @Lob
    @Column(name = "COLUMN_DESCRIPTION")
    @ApiParam(value ="列描述")
    private String columnDescription;

//    @Lob
//    @Column(name="COLUMN_HTML")
//    @ApiParam(value ="列html")
//    private String columnHtml;
}
