package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 * @Description :容器类型
 * @Reference :
 * @Author : 容器类型
 * @CreateDate : 2019-11-07 16:06
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "WMS_PACKAGE_SPEC")
@Api("包装规格")
public class WmsPackageSpec extends BaseBean {
    private static final long serialVersionUID = 4849044986767609445L;
    @ApiParam(value = "包装规格代码")
    private String specCode;

    @Column(name = "SPEC_NAME")
    @ApiParam(value = "包装规格名称")
    private String specName;

    @Column(name = "QTY")
    @ApiParam(value = "包装数量")
    private Double qty;

    @Column(name = "PARENT_SPEC")
    @ApiParam(value = "上级规格")
    private String parentSpec;

    @Column(name = "SPEC_LEVEL")
    @ApiParam(value = "规格层级")
    private Integer specLevel;

    @Column(name = "IS_MIXED")
    @ApiParam(value = "是否混包")
    private Integer isMixed;


    @Column(name = "POCKET_TYPE")
    @ApiParam(value = "容器类型")
    private String pocketType;

    @ApiParam(value = "上级规格名称")
    @Transient
    private String parentName;
}
