package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 库区物料
 * @Reference :
 * @Author : jessica.chen
 * @CreateDate : 2018-11-07 14:21
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="WMS_ZONE_PART")
@Api("库区物料")
public class WmsZonePart extends BaseBean{

    private static final long serialVersionUID = 9214639813072592546L;
    @Column(name="ZONE_NO")
    @ApiParam("存储区编号")
    private String zoneNo;

    @Column(name="PART_NO")
    @ApiParam("物料编码")
    private String partNo;

    @Column(name="PART_NAME_RDD")
    @ApiParam("物料名称")
    private String partNameRdd;

    @Column(name="PULL_QTY", columnDefinition = "decimal(18,8)")
    @ColumnDefault("0")
    @ApiParam(value = "拉动数量", example = "0")
    private Double pullQty;

    @Column(name="MAX", columnDefinition = "decimal(18,8)")
    @ColumnDefault("0")
    @ApiParam(value = "最大值", example = "0")
    private Double max;

    @Column(name="MIN", columnDefinition = "decimal(18,8)")
    @ColumnDefault("0")
    @ApiParam(value = "最小值", example = "0")
    private Double min;

    @Column(name = "IS_GENERATE_PICKLIST")
    @ApiParam(value = "是否生成领料单", example = "2")
    private Integer isGeneratePickList;

    @Column(name="MOQ", columnDefinition = "decimal(18,8)")
    @ColumnDefault("0")
    @ApiParam(value = "起订量", example = "0")
    private Double moq;

    @Column(name="SAFETY_QTY", columnDefinition = "decimal(18,8)")
    @ColumnDefault("0")
    @ApiParam(value = "安全量", example = "0")
    private Double safetyQty;
}