package cn.estsh.i3plus.pojo.wms.bean.dynamic;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : WMS搜索元素菜单关系表
 * @Reference :
 * @Author : sjc
 * @CreateDate : 2020-01-07 09:06
 * @Modify:
 **/
@Data
@Entity
@Table(name="WMS_SEARCHELEMENT_FUNCTION")
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api(value="WMS搜索元素菜单关系表",description = "WMS搜索元素菜单关系表")
public class WmsSearchElementFunction extends BaseBean {

    private static final long serialVersionUID = 3903166651913139063L;
    @Column(name = "FUNCTION_ID")
    @ApiParam(value = "功能菜单ID")
    private Long functionId;

    @Column(name = "GROUP_NAME")
    @ApiParam(value = "组名称")
    private String groupName;

    @Column(name = "SEARCH_NAME")
    @ApiParam(value = "搜索名称")
    private String searchName;

    @Column(name = "SEARCH_ELEMENT_ID")
    @ApiParam(value = "搜索元素ID")
    private Long searchElementId;

    @Column(name = "GROUP_CONNECTOR")
    @ApiParam(value = "组条件连接符")
    private String groupConnector;

    @Column(name = "USER_CODE")
    @ApiParam(value = "用户编号")
    private String userCode;

    @Column(name = "IS_SHARE")
    @ApiParam(value = "是否共享")
    private Integer isShare;
}
