package cn.estsh.i3plus.pojo.wms.dto;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.io.Serializable;

/**
 * @Description :装车单入参
 * @Reference :
 * @Author : gcj
 * @CreateDate : 2019-12-07 16:06
 * @Modify:
 **/
@Api("装车单入参")
@Data
public class WmsTmsShipDto extends BaseDto implements Serializable {

    @ApiParam("物料号")
    private String partNo;

    @ApiParam("单据号")
    private String moveNo;

    @ApiParam("是否删除，默认否")
    protected Integer isDeleted = 2;

    @ApiParam("是否有效，默认是")
    protected Integer isValid = 1;

    @ApiParam("工厂代码")
    protected String organizeCode;

    @ApiParam("ID")
    private Long id;

    @ApiParam(value ="道口")
    private String dockNo;

    @ApiParam(value ="承运商编号")
    private String vendorNo;

    @ApiParam(value ="承运商名称RDD")
    private String vendorName;

    @ApiParam(value ="驾驶员编号")
    private String driverNo;

    @ApiParam(value ="驾驶员名称RDD")
    private String driverName;

    @ApiParam(value ="驾驶员联系方式RDD")
    private String phone;

    @ApiParam(value ="单据状态")
    private Integer orderStatus;

    @ApiParam(value ="车牌号RDD")
    private String carNo;

    @ApiParam("回执单地址")
    private String pathUrl;

    @ApiParam("关联单号")
    private String refOrderNo;

    @ApiParam("开始时间")
    private String createDateTimeStart;

    @ApiParam("结束时间")
    private String createDateTimeEnd;
}
